// main.h

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

typedef struct SpotlightPrefs {
	EventModifiers activateModifiers, disableModifiers;
	unsigned short spotlightSize;
	Boolean switchToFinder, hideApps, oneLayer;
	
	char reserved[100];
} SpotlightPrefs;

enum {
	uppShowSpotlightInfo = kThinkCStackBased
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Point)))
		| STACK_ROUTINE_PARAMETER(1, SIZE_CODE(sizeof(Boolean))),
	
	uppMakeSpotlightInfo = kThinkCStackBased
};

typedef struct SpotlightGlobals {
// spotlight tracking globals
	Boolean active, activating;	
	RgnHandle spotlightRgn, oldlightRgn, newlightRgn;
	RgnHandle scratchRgn;
	Point lightCenter;

// misc globals
	SpotlightPrefs prefs;
	ProcessSerialNumber finderPSN;
	WindowPtr lastModalDialog;

// globals required by other code fragments
	Boolean deactivating;
	DragDrawingUPP theirDrawUPP, myDrawUPP;
	UniversalProcPtr dragDispatchAddr;
	UniversalProcPtr showSpotlightUPP, makeSpotlightUPP;
} SpotlightGlobals;

extern SpotlightGlobals glob;

void MoveSpotlightOffscreen(void);
void MakeSpotlightRgn(void);

#ifdef __cplusplus
}
#endif